
function output = leaky_step(t, dt, structure, input, neuromodulator)

structure.baseline=structure.baseline + ((rand(1, length(structure.activity(t,:)))*2-1)/10) .*structure.noise;

%action potential
structure.potential(t,:) = structure.potential(t-1,:) + (dt./structure.decay).*(-structure.potential(t-1,:) + ...
                            structure.baseline + (structure.epsilon+structure.lambda*neuromodulator)* ...
                            (input + (structure.activity(t-1,:)*structure.self_w)));

%transfer function
structure.activity(t,:) = max (0, tanh(structure.potential(t,:).*(structure.potential(t,:)>structure.th_out)));

output = structure;