function exp_structure=compute_wave(vector, interval)

pos_max=1;
pos_min=1;
max_index=0;
min_index=0;
for i=interval(1):interval(2)-1
    if vector(i)>vector(i-1) && vector(i)>vector(i+1)
        max_index(pos_max)=i;
        pos_max=pos_max+1;
    elseif vector(i)<vector(i-1) && vector(i)<vector(i+1)
        min_index(pos_min)=i;
        pos_min=pos_min+1;        
    end
end
if length(max_index)>=2
    period=abs(max_index(2)-max_index(1));
else
    period=0;
end
if  max_index(1)>0 && min_index(1)>0
    amplitude=abs(vector(max_index(1)) - vector(min_index(1)));
    centre_line=abs(amplitude/2 + vector(min_index(1)));
    peak=max_index(1);
else
    amplitude=0;
    centre_line=0;
    peak=0;
end

exp_structure=[period amplitude centre_line peak];