function exp_structure=exp_error(output, T)

load('sample_data_oscillations.mat')

% simple distance comparison between target and actual time series
error = 0; %sum(sum(abs(output - target_output)));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%comparison of period, amplitude and centre line of wave functions
for n=1:length(output(1,:))
    for int=2:4
    output_wave=compute_wave(output(:,n), [T/5*int T]);
    target_wave=compute_wave(target_output(:,n), [T/5*int T]);
    %comparison: period
    error=error+abs(target_wave(1)-output_wave(1))^2;
    %comparison: amplitude
    error=error+abs((target_wave(2)-output_wave(2))*500)^2;
    %comparison: centre line distance
    error=error+abs((target_wave(3)-output_wave(3))*500)^2;
    %comparison: peak index
    error=error+abs(target_wave(4)-output_wave(4));
    end
end


%%further option to give similar error-weight above a threshold (and avoid
%%ranking of part of the results)
% threshold=10000;
% error=error*(error<threshold)+threshold*(error>threshold);

exp_structure = error;